﻿Imports System.Data.OleDb
Public Class Form1
    Dim GrpDt As New DataTable 'グラフ用集計データテーブル
    Dim current_day As Date
    Dim ShortDt As New DataTable
    Dim IpMacDhcpDt As New DataTable 'IP->mac addressテーブル DHCPログから取得
    Dim HostDtCopy As New DataTable 'IP->ホスト名テーブル Copy
    Dim DnsHostDtCopy As New DataTable 'DNSホスト->IP テーブル DNSログから取得 Copy
    Dim GetHostFlg As Boolean 'ホスト名検索可能フラグ
    Dim CBIAr() As ComboBox
    Dim CBKAr() As ComboBox
    Dim TBJAr() As TextBox
    Dim SqlSubString As String = ""

    Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        SettingIniPathName = System.Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) _
                           + "\" + Me.ProductName
        Dim curpath As String
        curpath = SettingIniPathName + "\" + Me.ProductName + ".ini"

        MdbPath = System.Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) _
                           + "\SyslogReceive2"
        ParentProductName = "SyslogReceive2"
        TextBox4.Text = "5"
        FontSize = 10
        If System.IO.File.Exists(curpath) Then
            Dim sr As System.IO.StreamReader = New System.IO.StreamReader(curpath)
            Dim head As String
            head = sr.ReadLine() '設定ファイルバージョンのチェック
            If head = Me.ProductName Then

                'MDBパス
                MdbPath = sr.ReadLine()
                '親プログラム名
                ParentProductName = sr.ReadLine()
                '検索幅(分)
                Dim m As String = sr.ReadLine()
                Try
                    If CInt(m) > 0 Then
                        If CInt(m) > 0 Then
                            SearchInterval = CInt(m)
                            TextBox4.Text = SearchInterval.ToString
                        End If
                    End If
                Catch ex As Exception
                    ErrorSave("LoadIniFile:検索幅(分)[" + m + "]")
                End Try
                '文字サイズ----------------------------
                Try
                    m = sr.ReadLine()
                    If Single.Parse(m) > 0 Then
                        FontSize = Single.Parse(m)
                    End If
                Catch ex As Exception
                    ErrorSave("LoadIniFile:文字サイズ[" + m + "]")
                End Try
                'close----------------------------
                sr.Close()
            Else
                sr.Close()
                MsgBox("別のソフトの設定ファイルみたいです")
            End If
        Else 'Iniファイルがない
            'MsgBox("設定ファイルがありません。初期設定を行ってください。")
        End If
        '-----------------------------------


        current_day = Now.AddDays(-1)
        DateTimePicker1.Value = current_day

        CBIAr = New ComboBox() {ComboBox2, ComboBox4, ComboBox6, ComboBox8}
        CBKAr = New ComboBox() {ComboBox1, ComboBox3, ComboBox5, ComboBox7}
        TBJAr = New TextBox() {TextBox5, TextBox6, TextBox7, TextBox8}
        Dim ItmAr() As String = {"label", "lan", "tcp_udp", "in_out", "in_ip", "in_port", "out_ip", "out_port"}
        Dim KgAr() As String = {"=", ">", "<", ">=", "<=", "<>", "含む", "前方一致", "後方一致"}
        For i = 0 To 3
            CBIAr(i).Items.Clear()
            For j = 0 To ItmAr.Length - 1
                CBIAr(i).Items.Add(ItmAr(j))
            Next
        Next
        For i = 0 To 3
            CBKAr(i).Items.Clear()
            For j = 0 To ItmAr.Length - 1
                CBKAr(i).Items.Add(KgAr(j))
            Next
        Next
        '-----------------------------------
        Dim f As New Font(ListBox1.Font.Name, FontSize)
        ListBox1.Font = f
        ListBox2.Font = f
        TextBox1.Font = f
        '-----------------------------------
        TableLayoutPanel2.ColumnStyles(1).Width = 0
        '-----------------------------------
        SplitContainer3.SplitterDistance = SplitContainer3.Height
        DataGridView1.Visible = False
        '-----------------------------------
        '.Columns.Append(ADOX.DataTypeEnum.adWChar, 1)
        '.Columns.Append(ADOX.DataTypeEnum.adWChar, 1)
        '.Columns.Append(ADOX.DataTypeEnum.adWChar, 1)
        '.Columns.Append(ADOX.DataTypeEnum.adWChar, 1)
        '.Columns.Append(ADOX.DataTypeEnum.adInteger)
        '.Columns.Append(ADOX.DataTypeEnum.adInteger)
        '.Columns.Append(ADOX.DataTypeEnum.adSmallInt)
        '.Columns.Append(ADOX.DataTypeEnum.adInteger)
        '.Columns.Append(ADOX.DataTypeEnum.adSmallInt)
    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        OpenFileDialog1.Filter = "*.mdb|*.mdb"
        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            MdbLogPathName = OpenFileDialog1.FileName
            Dim p As String = MdbLogPathName.Substring(0, MdbLogPathName.LastIndexOf("\"))
            Dim n As String = MdbLogPathName.Substring(MdbLogPathName.LastIndexOf("\"))
            MdbHostPathName = p + n.Replace(ParentProductName, ParentProductName + "Hostname") 'SyslogReceive2Hostname_20161112
            If MdbFileCheck() Then
                DateTimePicker1.Text = current_day
                Count()
                GraphDrow()
            Else
                GrpDt = New DataTable
                GraphDrow()
                Label2.Text = "データファイルが読み込まれていません"
            End If
        End If
    End Sub
    Private Function MdbFileCheck() As Boolean
        'Logファイルをチェック
        If MdbGetTableNames(MdbLogPathName) = False Then
            MsgBox("Logファイルを読み込めません")
            MdbLogPathName = ""
            Return False
        Else
            If TableNames.Length = 1 Then
                If TableNames(0) = "LogDataTable" Then
                    TextBox2.Text = MdbLogPathName
                Else
                    MsgBox("Logファイルではありません")
                    MdbLogPathName = ""
                    Return False
                End If
            Else
                MsgBox("Logファイルではありません")
                MdbLogPathName = ""
                Return False
            End If
        End If

        '日付チェック
        Dim n As String = MdbLogPathName.Substring(MdbLogPathName.LastIndexOf("\"))
        Dim r As New System.Text.RegularExpressions.Regex("[0-9]{8}", System.Text.RegularExpressions.RegexOptions.IgnoreCase)
        Dim m As System.Text.RegularExpressions.Match = r.Match(n) '日付
        If m.Success Then
            Try
                Dim s As String = m.Value.ToString
                current_day = CDate(s.Substring(0, 4) + "/" + s.Substring(4, 2) + "/" + s.Substring(6, 2))
                Label2.Text = "日付：" + current_day.Date
            Catch ex As Exception
                MsgBox("日付が判定できません")
                Return False
            End Try
        Else
            MsgBox("日付が判定できません")
            Return False
        End If

        'Hostファイルをチェック Hostファイルはなくても集計はできるので処理は続ける
        'Hostファイルが使えない場合はMdbHostPathNameをNULLにして目印にする
        TextBox1.Text = MdbLogPathName + vbCrLf + n + vbCrLf + MdbHostPathName + vbCrLf + current_day.Date

        If MdbGetTableNames(MdbHostPathName) = False Then
            MsgBox("Hostファイルを読み込めません")
            MdbHostPathName = ""
        Else
            If TableNames.Length = 3 Then
                If Array.IndexOf(TableNames, "HostDt") >= 0 And Array.IndexOf(TableNames, "IpMacDhcpDt") >= 0 And Array.IndexOf(TableNames, "DnsHostDt") >= 0 Then
                Else
                    MsgBox("Hostファイルではありません")
                    MdbHostPathName = ""
                End If
            Else
                MsgBox("Hostファイルではありません")
                MdbHostPathName = ""
            End If
        End If
        'TextBox1.Text = ""
        'For i = 0 To TableNames.Length - 1
        '    TextBox1.Text = TextBox1.Text + TableNames(i) + vbCrLf
        'Next
        Return True
    End Function

    Private Sub Count()
        If CheckBox1.Checked Then
            SqlSubString = TextBox9.Text
        Else
            SqlSubString = ""
        End If
        'Dim sqlstring2 As String = "SELECT COUNT(*) AS kensuu, in_out, tcp_udp, out_ip, out_port FROM LogDataTable WHERE date_time >=  #" + ctime.AddMinutes(-1 * min).ToString("yyyy/MM/dd HH:mm") + "# AND  date_time <  #" + ctime.ToString("yyyy/MM/dd HH:mm") + "# GROUP BY in_out, tcp_udp, out_ip, out_port ORDER BY COUNT(*) desc"
        'Dim sqlstring As String = "SELECT COUNT(*) AS kensuu, ROUND(date_time/500)*5  FROM LogDataTable  GROUP BY ROUND(date_time/500)*5"
        'Dim sqlstring As String = "SELECT COUNT(*) AS kensuu, (date_time-(date_time MOD 500))/100  FROM LogDataTable  GROUP BY (date_time-(date_time MOD 500))/100"
        'Dim sqlstring As String = "SELECT COUNT(*) AS kensuu, (date_time \ 500)*5  FROM LogDataTable  GROUP BY (date_time \ 500)*5"
        'Dim sqlstring As String = "SELECT COUNT(*) AS kensuu, FLOOR(date_time/3600)  FROM LogDataTable  GROUP BY FLOOR(date_time/3600)"'FLOORは使えない
        Dim sqlstring As String = "SELECT COUNT(*) AS kensuu, (date_time \ 500)*5  FROM LogDataTable  "
        If SqlSubString <> "" Then
            sqlstring = sqlstring + " WHERE " + SqlSubString
        End If
        sqlstring = sqlstring + " GROUP BY (date_time \ 500)*5"
        GrpDt.Rows.Clear()
        GrpDt.Columns.Clear()

        Me.Cursor = Cursors.WaitCursor '砂時計のカーソルを表示する
        MdbDataAdapterFill(MdbLogPathName, sqlstring, GrpDt)
        Me.Cursor = Cursors.Default '元のカーソルに戻す（通常のカーソル）

        'DataGridView1.DataSource = GrpDt SqlSubString
        'MsgBox(dt.Columns.Count)
        'MsgBox(dt.Rows.Count)
    End Sub
    Private Sub GraphDrow()
        Dim W As Integer = PictureBox1.Width
        Dim H As Integer = PictureBox1.Height
        'ListBox1.Items.Add(W.ToString + ", " + H.ToString)
        Dim img As Bitmap
        img = New Bitmap(W, H)
        'ImageオブジェクトのGraphicsオブジェクトを作成する
        Dim g As Graphics = Graphics.FromImage(img)

        '全体を白で塗りつぶす
        g.FillRectangle(Brushes.White, g.VisibleClipBounds)

        Dim sw As Single = W
        Dim sh As Single = H
        Dim sxp As Single = W / 24
        Dim sx As Single = 0
        Dim sy As Single = sh / 5 * 4
        Dim fnt As New Font("MS UI Gothic", 15)
        For i = 0 To 24
            sx = sxp * i
            g.DrawLine(Pens.Black, sx, 0, sx, sy)
            If i Mod 2 = 0 Then
                g.DrawString(i.ToString, fnt, Brushes.Black, sx - 5, sy)
            End If
        Next
        g.DrawLine(Pens.Black, 0, sy, sw, sy)
        Dim mx As Integer = 0
        Dim dmin As Integer = current_day.Day * 10000
        Dim dmax As Integer = current_day.Day * 10000 + 9999
        For i = 0 To GrpDt.Rows.Count - 1
            If mx < GrpDt.Rows(i).Item("kensuu") Then
                If GrpDt.Rows(i).Item(1) >= dmin And GrpDt.Rows(i).Item(1) < dmax Then
                    mx = GrpDt.Rows(i).Item("kensuu")
                End If
            End If
        Next
        Dim cday As Integer
        Dim cct As Integer
        Dim syd As Single
        Dim sxd As Single
        Dim pn As New Pen(Color.Blue, 3)

        For i = 0 To GrpDt.Rows.Count - 1
            cday = GrpDt.Rows(i).Item(1)
            If cday >= dmin And cday <= dmax Then
                cct = GrpDt.Rows(i).Item("kensuu")
                syd = sy / mx * (mx - cct)
                sxd = sw / (24 * 12) * (((cday Mod dmin) \ 100) * 12 + ((cday Mod dmin) Mod 100) / 5)
                g.DrawLine(pn, sxd, syd, sxd, sy)
            End If
        Next
        g.DrawString(mx.ToString, fnt, Brushes.Black, 0, 0)

        'MsgBox(m)
        'リソースを解放する
        g.Dispose()
        PictureBox1.Image = img
        PictureBox1.Invalidate()
    End Sub

    Private Sub PictureBox1_MouseClick(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseClick
        'MsgBox(e.Location.X.ToString + ", " + e.Location.Y.ToString)
        Dim x As Integer = 24 * 60 * e.Location.X / PictureBox1.Width
        TextBox3.Text = (x \ 60).ToString + ":" + (x Mod 60).ToString
        Aggregate()
        'GraphDrow2()
    End Sub
    Private Sub PictureBox2_MouseClick(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles PictureBox2.MouseClick
        Dim x As Integer = 24 * 60 * e.Location.X / PictureBox1.Width
        TextBox3.Text = (x \ 60).ToString + ":" + (x Mod 60).ToString
        Aggregate()
    End Sub

    Private Sub GraphDrow2()
        Dim h As Integer
        Dim m As Integer
        Try
            h = CInt(TextBox3.Text.Substring(0, TextBox3.Text.IndexOf(":")))
            m = CInt(TextBox3.Text.Substring(TextBox3.Text.IndexOf(":") + 1))
        Catch ex As Exception
            Exit Sub
        End Try
        Dim a As Integer
        Try
            a = CInt(TextBox4.Text)
        Catch ex As Exception
            Exit Sub
        End Try

        Dim PBW As Integer = PictureBox2.Width
        Dim PBH As Integer = PictureBox2.Height
        'ListBox1.Items.Add(W.ToString + ", " + H.ToString)
        Dim img As Bitmap
        img = New Bitmap(PBW, PBH)
        'ImageオブジェクトのGraphicsオブジェクトを作成する
        Dim g As Graphics = Graphics.FromImage(img)

        '全体を白で塗りつぶす
        g.FillRectangle(Brushes.White, g.VisibleClipBounds)

   
        Dim sx As Single = PBW / (24 * 60) * (h * 60 + m)
        Dim aw As Single = PBW / (24 * 60) * (a)
        g.FillRectangle(Brushes.Red, sx, 0, aw, PBH)
 
        'リソースを解放する
        g.Dispose()
        PictureBox2.Image = img
        PictureBox2.Invalidate()
    End Sub


    Private Sub PictureBox1_SizeChanged(sender As Object, e As System.EventArgs) Handles PictureBox1.SizeChanged
        GraphDrow()
        GraphDrow2()
    End Sub

    '集計ボタン
    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        'Dim h As Integer
        'Dim m As Integer
        'Try
        '    h = CInt(TextBox3.Text.Substring(0, TextBox3.Text.IndexOf(":")))
        '    m = CInt(TextBox3.Text.Substring(TextBox3.Text.IndexOf(":") + 1))
        '    'MsgBox(h.ToString + ":" + m.ToString)
        'Catch ex As Exception
        '    MsgBox("開始時刻が不正です")
        '    Exit Sub
        'End Try
        'Dim a As Integer
        'Try
        '    a = CInt(TextBox4.Text)
        'Catch ex As Exception
        '    MsgBox("集計時間(分)が不正です")
        '    Exit Sub
        'End Try
        'GraphDrow2()
        'Aggregate(h, m, a)
        Aggregate()
    End Sub
    'Private Sub Aggregate(ByVal h As Integer, ByVal m As Integer, ByVal a As Integer)
    Private Sub Aggregate()
        Dim h As Integer
        Dim m As Integer
        Try
            h = CInt(TextBox3.Text.Substring(0, TextBox3.Text.IndexOf(":")))
            m = CInt(TextBox3.Text.Substring(TextBox3.Text.IndexOf(":") + 1))
            'MsgBox(h.ToString + ":" + m.ToString)
        Catch ex As Exception
            MsgBox("開始時刻が不正です")
            Exit Sub
        End Try
        Dim a As Integer
        Try
            a = CInt(TextBox4.Text)
        Catch ex As Exception
            MsgBox("集計時間(分)が不正です")
            Exit Sub
        End Try
        Cursor.Current = Cursors.WaitCursor
        GraphDrow2()

        Dim ds As Date = CDate(current_day.Date + " " + h.ToString + ":" + m.ToString)

        Dim ss As Integer = ds.Day * 1000000 + ds.Hour * 10000 + ds.Minute * 100
        Dim de As Date = ds.AddMinutes(a)
        Dim es As Integer
        If de.Day <> ds.Day Then
            es = ds.Day * 1000000 + 23 * 10000 + 59 * 100 + 59
        Else
            es = de.Day * 1000000 + de.Hour * 10000 + de.Minute * 100
        End If
        'ホスト名検索用テーブル作成
        If MdbHostPathName <> "" Then
            Dim f1, f2, f3 As Boolean
            'IP->ホスト名テーブル Copy
            Dim sqlstringH As String = "SELECT * FROM HostDt WHERE delete_time >=  " + ss.ToString + " and " + " cleate_time <= " + es.ToString
            HostDtCopy.Rows.Clear()
            HostDtCopy.Columns.Clear()
            f1 = MdbDataAdapterFill(MdbHostPathName, sqlstringH, HostDtCopy)
            'DNSホスト->IP テーブル DNSログから取得 Copy
            Dim sqlstringD As String = "SELECT * FROM DnsHostDt WHERE delete_time >=  " + ss.ToString + " and " + " cleate_time <= " + es.ToString
            DnsHostDtCopy.Rows.Clear()
            DnsHostDtCopy.Columns.Clear()
            f2 = MdbDataAdapterFill(MdbHostPathName, sqlstringD, DnsHostDtCopy)
            'IP->mac addressテーブル DHCPログから取得
            Dim sqlstringM As String = "SELECT * FROM IpMacDhcpDt WHERE delete_time >=  " + ss.ToString + " and " + " cleate_time <= " + es.ToString
            IpMacDhcpDt.Rows.Clear()
            IpMacDhcpDt.Columns.Clear()
            f3 = MdbDataAdapterFill(MdbHostPathName, sqlstringM, IpMacDhcpDt)
            If f1 And f2 And f3 Then
                GetHostFlg = True
                Label6.Text = ""
            Else
                GetHostFlg = False
                Label6.Text = "ホスト名検索不能"
            End If
            'DataGridView1.DataSource = HostDtCopy
        Else
            Label6.Text = "ホスト名検索不能"
            GetHostFlg = False
        End If
        'Log検索
        If CheckBox1.Checked Then
            SqlSubString = TextBox9.Text
        Else
            SqlSubString = ""
        End If
        'Dim sqlstringL As String = "SELECT * FROM LogDataTable WHERE date_time >=  " + ss.ToString + " and " + " date_time < " + es.ToString
        Dim sqlstringL As String = "SELECT * FROM LogDataTable WHERE date_time >=  " + ss.ToString + " and " + " date_time < " + es.ToString
        If SqlSubString <> "" Then
            sqlstringL = sqlstringL + " AND (" + SqlSubString + ") "
        End If
        ShortDt.Rows.Clear()
        ShortDt.Columns.Clear()
        If MdbDataAdapterFill(MdbLogPathName, sqlstringL, ShortDt) = True Then
            If DataGridView1.Visible Then
                DataGridView1.DataSource = ShortDt
            End If
            '------IN側IPで集計-----------------------------------------------------------
            Dim CDt As New DataTable
            Dim KeyColumn(2) As DataColumn
            KeyColumn(0) = CDt.Columns.Add("in_ip", Type.GetType("System.Int32"))
            KeyColumn(1) = CDt.Columns.Add("tcp_udp", Type.GetType("System.Char"))
            KeyColumn(2) = CDt.Columns.Add("in_out", Type.GetType("System.Char"))
            CDt.Columns.Add("count", Type.GetType("System.Int32"))
            CDt.PrimaryKey = New DataColumn() {KeyColumn(0), KeyColumn(1), KeyColumn(2)}
            For i = 0 To ShortDt.Rows.Count - 1
                Dim k(2) As Object
                k(0) = ShortDt.Rows(i).Item("in_ip")
                k(1) = ShortDt.Rows(i).Item("tcp_udp")
                k(2) = ShortDt.Rows(i).Item("in_out")
                Dim foundRow As DataRow = CDt.Rows.Find(k)
                If foundRow Is Nothing Then
                    CDt.Rows.Add(ShortDt.Rows(i).Item("in_ip"), ShortDt.Rows(i).Item("tcp_udp"), ShortDt.Rows(i).Item("in_out"), 1)
                Else
                    foundRow.Item("count") = foundRow.Item("count") + 1
                End If
            Next
            Dim cdv As DataView = New DataView(CDt)
            cdv.Sort = "count DESC"
            'MsgBox("集計終わり:" + CDt.Rows.Count.ToString)
            Debug.WriteLine("Aggregate:集計終わり:" + CDt.Rows.Count.ToString)

            'Dim ndt As New DataTable
            Dim str0 As String
            'ListboxEnabled(False)
            ListBox1.Items.Clear()
            'str0 = "-- IN IP -- " + ctime.AddMinutes(-1 * min).ToString("yyyy/MM/dd HH:mm") + " - " + ctime.ToString("yyyy/MM/dd HH:mm") + " ----" + vbCrLf
            'ListBox1.BeginInvoke(New Action(Of String)(AddressOf Listbox1ItemsAdd), str0)
            ListBox1.Items.Add("Count, IP, tcp/udp, in/out, (host name)")
            'Stopwatchオブジェクトを作成する 

            For i = 0 To cdv.Count - 1
                Dim ip As String = InttoIP(cdv(i).Item("in_ip"))
                Dim hostname As String = GetHostName(cdv(i).Item("in_ip"))
                Dim address As String = GetMacAddress(cdv(i).Item("in_ip"))

                str0 = cdv(i).Item("count").ToString + ", "
                str0 = str0 + ip + ", "
                str0 = str0 + cdv(i).Item("tcp_udp").ToString + ", "
                str0 = str0 + cdv(i).Item("in_out").ToString + ", "
                str0 = str0 + "(" + hostname + ")"
                str0 = str0 + "(" + address + ")"
                ListBox1.Items.Add(str0)
            Next

            '------OUT側IPで集計-----------------------------------------------------------
            Dim CDt2 As New DataTable
            Dim KeyColumn2(3) As DataColumn
            KeyColumn2(0) = CDt2.Columns.Add("out_ip", Type.GetType("System.Int32"))
            KeyColumn2(1) = CDt2.Columns.Add("tcp_udp", Type.GetType("System.Char"))
            KeyColumn2(2) = CDt2.Columns.Add("in_out", Type.GetType("System.Char"))
            KeyColumn2(3) = CDt2.Columns.Add("out_port", Type.GetType("System.Int32"))
            CDt2.Columns.Add("count", Type.GetType("System.Int32"))
            CDt2.PrimaryKey = New DataColumn() {KeyColumn2(0), KeyColumn2(1), KeyColumn2(2)}
            For i = 0 To ShortDt.Rows.Count - 1
                Dim k(2) As Object
                k(0) = ShortDt.Rows(i).Item("out_ip")
                k(1) = ShortDt.Rows(i).Item("tcp_udp")
                k(2) = ShortDt.Rows(i).Item("in_out")
                Dim foundRow As DataRow = CDt2.Rows.Find(k)
                If foundRow Is Nothing Then
                    CDt2.Rows.Add(ShortDt.Rows(i).Item("out_ip"), ShortDt.Rows(i).Item("tcp_udp"), ShortDt.Rows(i).Item("in_out"), ShortDt.Rows(i).Item("out_port"), 1)
                Else
                    foundRow.Item("count") = foundRow.Item("count") + 1
                End If
            Next
            Dim cdv2 As DataView = New DataView(CDt2)
            cdv2.Sort = "count DESC"
            'MsgBox("集計終わり2:" + CDt.Rows.Count.ToString)
            Debug.WriteLine("Aggregate:集計終わり2:" + CDt.Rows.Count.ToString)

            ListBox2.Items.Clear()
            'str0 = "-- OUT IP -- " + ctime.AddMinutes(-1 * min).ToString("yyyy/MM/dd HH:mm") + " - " + ctime.ToString("yyyy/MM/dd HH:mm") + " ----" + vbCrLf
            'ListBox2.Items.Add(str0)
            ListBox2.Items.Add("Count, IP, port, tcp/udp, in/out, (host name)")
            For i = 0 To cdv2.Count - 1
                Dim ip As String = InttoIP(cdv2(i).Item("out_ip"))
                Dim port As Integer = cdv2(i).Item("out_port") + 32768
                Dim hostname As String = GetHostName(cdv2(i).Item("out_ip"))
                str0 = cdv2(i).Item("count").ToString + ", "
                str0 = str0 + ip + ", "
                str0 = str0 + port.ToString + ", "
                str0 = str0 + cdv2(i).Item("tcp_udp").ToString + ", "
                str0 = str0 + cdv2(i).Item("in_out").ToString + ", "
                str0 = str0 + "(" + hostname + ")"
                ListBox2.Items.Add(str0)
            Next

        End If
        Cursor.Current = Cursors.Default
        'DataGridView1.DataSource = ShortDt
    End Sub

    Private Sub DateTimePicker1_ValueChanged(sender As Object, e As System.EventArgs) Handles DateTimePicker1.ValueChanged
        Dim dy As Date = CDate(DateTimePicker1.Text)
        If current_day = dy Then
            Exit Sub
        End If
        Dim name As String = MdbPath + "\" + ParentProductName + dy.ToString("_yyyyMMdd") + ".mdb"
        MdbLogPathName = name
        MdbHostPathName = MdbPath + "\" + ParentProductName + "Hostname" + dy.ToString("_yyyyMMdd") + ".mdb"
        'current_day = dy
        'Label2.Text = dy.Date
        If MdbFileCheck() Then
            TextBox2.Text = MdbLogPathName
            Count()
            GraphDrow()
        Else
            GrpDt = New DataTable
            GraphDrow()
            Label2.Text = "データファイルが読み込まれていません"
        End If
        'If System.IO.File.Exists(name) Then
        '    MdbLogPathName = name
        '    MdbHostPathName = MdbPath + "\" + ParentProductName + "Hostname" + dy.ToString("_yyyyMMdd") + ".mdb"
        '    'current_day = dy
        '    'Label2.Text = dy.Date
        '    If MdbFileCheck() Then
        '        TextBox2.Text = MdbLogPathName
        '    End If
        'Else
        '    MsgBox("データファイルが見つかりません")
        'End If
    End Sub
    Private Function GetHostName(ByVal ip As Integer) As String
        If GetHostFlg = False Then
            Return ""
        End If
        'IPから検索したホスト名を検索
        Dim hostname As String = ""
        Try
            Dim dr() As DataRow = HostDtCopy.Select("ipval = " + ip.ToString)
            If dr.Length > 0 Then
                hostname = dr(0).Item("host_name").ToString
            End If

        Catch ex As Exception
            ErrorSave("GetHostName1(" + ip.ToString + "): " + ex.ToString)
        End Try

        'dnsメッセージから取得したホスト名を検索
        Dim hostname2 As String = ""
        Try
            Dim dr() As DataRow = DnsHostDtCopy.Select("ipval = " + ip.ToString)
            If dr.Length > 0 Then
                hostname2 = dr(0).Item("host_name").ToString
            End If
        Catch ex As Exception
            ErrorSave("GetHostName2(" + ip.ToString + "): " + ex.ToString)
        End Try

        'ホスト名を返す
        If hostname = hostname2 Then '一致した場合
            Return hostname
        Else '一致しない場合
            If (ip >= -1062731776 And ip <= -1062666241) Or (ip >= -1408237568 And ip <= -1407188993) Or (ip >= 167772160 And ip <= 184549375) Then
                'プライベートアドレスの場合はdnsメッセージからは取得できないので
                Return hostname
            Else
                'dnsメッセージからは取得したものを先に
                Return hostname2 + "*" + hostname
            End If

        End If

    End Function


    'mac address を探す
    Private Function GetMacAddress(ByVal ip As Integer) As String
        If GetHostFlg = False Then
            Return ""
        End If
        Dim macaddress As String = ""
        Try
            Dim dr() As DataRow = HostDtCopy.Select("ipval = " + ip.ToString)
            If dr.Length > 0 Then
                macaddress = dr(0).Item("mac_address").ToString
            End If
        Catch ex As Exception
            ErrorSave("GetMacAddress(" + ip.ToString + "): " + ex.ToString)
        End Try
        Try
            'mac address が見つからなかった場合DHCPメッセージから採ったmac addressを探す
            If macaddress = "" Or macaddress = "00-00-00-00-00-00" Then
                Dim dr() As DataRow = IpMacDhcpDt.Select("ipval = " + ip.ToString)
                If dr.Length > 0 Then
                    macaddress = dr(0).Item("mac_address")
                    'dr(0).Item("access_time") = Now
                End If
            End If
        Catch ex As Exception
            ErrorSave("GetMacAddress2(" + ip.ToString + "): " + ex.ToString)
        End Try
        Return macaddress
    End Function

    Private Sub ListBox1_Click(sender As Object, e As System.EventArgs) Handles ListBox1.Click
        If ListBox1.SelectedIndex >= 1 Then
            TextBox1.Text = ListBox1.SelectedItem + vbCrLf
            TextBox1.Text = TextBox1.Text + MoreInfoAggregateIn(ListBox1.SelectedItem.ToString).Replace("_", vbCrLf)
        End If

    End Sub

    Private Function MoreInfoAggregateIn(ByVal sstr As String) As String

        Dim strar() As String = sstr.Split(",")
        Dim rstr As String = ""
        If strar.Length > 3 Then
            'Stopwatchオブジェクトを作成する 
            Dim sw As New System.Diagnostics.Stopwatch()
            'ストップウォッチを開始する 
            sw.Start()
            Dim swstr As String = ""
            'Dim str As String = ""
            'Dim sqlstring2 As String = "SELECT COUNT(*) AS kensuu, in_out, tcp_udp, out_ip FROM LogDataTable WHERE date_time >=  #" + CheckMin.AddMinutes(-1 * AggregateShort).ToString("yyyy/MM/dd HH:mm") + "# AND  date_time <  #" + CheckMin.ToString("yyyy/MM/dd HH:mm#") + " GROUP BY in_out, tcp_udp, out_ip ORDER BY COUNT(*) desc"
            'Dim sqlstring2 As String = "SELECT COUNT(*) AS kensuu, label, lan, out_ip, out_port FROM LogDataTable WHERE date_time >=  #" + CheckMin.AddMinutes(-1 * AggregateShort).ToString("yyyy/MM/dd HH:mm") + "# AND  date_time <  #" + CheckMin.ToString("yyyy/MM/dd HH:mm#") + _
            '                           " AND in_ip = " + IPtoInt(strar(1)).ToString + " AND tcp_udp = '" + (strar(2)).ToString.Trim + "' AND in_out = '" + strar(3).ToString.Trim + "'" + _
            '                           " GROUP BY label, lan, out_ip, out_port ORDER BY COUNT(*) desc"
            'Dim dt2 As New DataTable
            Debug.WriteLine("MoreInfoAggregateIn-01") '-------------------
            'ShortDt_rwLock.AcquireWriterLock(Threading.Timeout.Infinite)
            'ErrorSave("MoreInfoAggregateIn1 Lock") '-------------------------
            Try
                Dim sqlstringD As String = "in_ip = " + IPtoInt(strar(1)).ToString + " AND tcp_udp = '" + (strar(2)).ToString.Trim + "' AND in_out = '" + strar(3).ToString.Trim + "'"
                Dim cdr() As DataRow
                cdr = ShortDt.Select(sqlstringD)
                Dim CDt As New DataTable
                Dim KeyColumn(3) As DataColumn
                KeyColumn(0) = CDt.Columns.Add("label", Type.GetType("System.Char"))
                KeyColumn(1) = CDt.Columns.Add("lan", Type.GetType("System.Char"))
                KeyColumn(2) = CDt.Columns.Add("out_ip", Type.GetType("System.Int32"))
                KeyColumn(3) = CDt.Columns.Add("out_port", Type.GetType("System.Int32"))
                CDt.Columns.Add("count", Type.GetType("System.Int32"))
                CDt.PrimaryKey = New DataColumn() {KeyColumn(0), KeyColumn(1), KeyColumn(2), KeyColumn(3)}
                'Debug.WriteLine("MoreInfoAggregateIn-02") '-------------------
                swstr = swstr + "1:" + sw.ElapsedMilliseconds.ToString + ", "
                For i = 0 To cdr.Length - 1
                    Dim k(3) As Object
                    k(0) = cdr(i).Item("label")
                    k(1) = cdr(i).Item("lan")
                    k(2) = cdr(i).Item("out_ip")
                    k(3) = cdr(i).Item("out_port")
                    Dim foundRow As DataRow = CDt.Rows.Find(k)
                    If foundRow Is Nothing Then
                        CDt.Rows.Add(cdr(i).Item("label"), cdr(i).Item("lan"), cdr(i).Item("out_ip"), cdr(i).Item("out_port"), 1)
                    Else
                        foundRow.Item("count") = foundRow.Item("count") + 1
                    End If
                    'Debug.WriteLine("MoreInfoAggregateIn-03-" + i.ToString) '-------------------
                Next
                Debug.WriteLine("MoreInfoAggregateIn-04") '-------------------
                swstr = swstr + "2:" + sw.ElapsedMilliseconds.ToString + ", "
                Dim cdv As DataView = New DataView(CDt)
                cdv.Sort = "count DESC"
                'MsgBox("集計終わり:" + CDt.Rows.Count.ToString)
                Debug.WriteLine("MoreInfoAggregateIn:集計終わり:" + CDt.Rows.Count.ToString)
                swstr = swstr + "3:" + sw.ElapsedMilliseconds.ToString + ", "

                'Dim dt2 As New DataTable
                Dim str0 As String = ""
                Dim ndt As New DataTable
                'str0 = "-- OUT IP -- " + CheckMin.AddMinutes(-1 * AggregateShort).ToString("yyyy/MM/dd HH:mm") + " - " + CheckMin.ToString("yyyy/MM/dd HH:mm") + " ----" + "_"
                rstr = rstr + str0
                rstr = rstr + "Count, IP, port, label, lan, (host name)" + "_"
                Debug.WriteLine("MoreInfoAggregateIn-05") '-------------------
                For i = 0 To cdv.Count - 1
                    Dim ip As String = InttoIP(cdv(i).Item("out_ip"))
                    Dim port As Integer = cdv(i).Item("out_port") + 32768
                    Dim hostname As String = GetHostName(cdv(i).Item("out_ip"))

                    str0 = cdv(i).Item("count").ToString + ", "
                    str0 = str0 + ip + ", "
                    str0 = str0 + port.ToString + ", "
                    str0 = str0 + cdv(i).Item("label").ToString + ", "
                    str0 = str0 + cdv(i).Item("lan").ToString + ", "
                    str0 = str0 + "(" + hostname + ")"
                    rstr = rstr + str0 + "_"
                    Debug.WriteLine("MoreInfoAggregateIn-06-" + i.ToString) '-------------------
                Next
            Catch ex As Exception
                ErrorSave("MoreInfoAggregateIn: (" + sstr + ") " + ex.ToString)
            End Try
            'ShortDt_rwLock.ReleaseWriterLock()
            'ErrorSave("MoreInfoAggregateIn1 Release") '-------------------------
            'ストップウォッチを止める 
            sw.Stop()
            If DebugFlg Then
                swstr = swstr + "4:" + sw.ElapsedMilliseconds.ToString + ", "
                rstr = rstr + swstr + "_"
            End If
            Debug.WriteLine("MoreInfoAggregateIn-07") '-------------------

        End If
        Return rstr
    End Function

    Private Sub ListBox2_Click(sender As Object, e As System.EventArgs) Handles ListBox2.Click
        If ListBox2.SelectedIndex >= 1 Then
            TextBox1.Text = ListBox2.SelectedItem
            TextBox1.Text = TextBox1.Text + MoreInfoAggregateOut(ListBox2.SelectedItem.ToString).Replace("_", vbCrLf)
        End If

    End Sub
    Private Function MoreInfoAggregateOut(ByVal sstr As String) As String
        Dim strar() As String = sstr.Split(",")
        Dim rstr As String = ""
        If strar.Length > 4 Then
            'Stopwatchオブジェクトを作成する 
            Dim sw As New System.Diagnostics.Stopwatch()
            Dim swstr As String = ""
            'ストップウォッチを開始する 
            sw.Start()
            'Dim str As String = ""
            'Dim sqlstring2 As String = "SELECT COUNT(*) AS kensuu, in_out, tcp_udp, out_ip FROM LogDataTable WHERE date_time >=  #" + CheckMin.AddMinutes(-1 * AggregateShort).ToString("yyyy/MM/dd HH:mm") + "# AND  date_time <  #" + CheckMin.ToString("yyyy/MM/dd HH:mm#") + " GROUP BY in_out, tcp_udp, out_ip ORDER BY COUNT(*) desc"
            'Dim sqlstring2 As String = "SELECT COUNT(*) AS kensuu, label, lan, in_ip FROM LogDataTable WHERE date_time >=  #" + CheckMin.AddMinutes(-1 * AggregateShort).ToString("yyyy/MM/dd HH:mm") + "# AND  date_time <  #" + CheckMin.ToString("yyyy/MM/dd HH:mm#") + _
            '                           " AND out_ip = " + IPtoInt(strar(1)).ToString + " AND tcp_udp = '" + (strar(3)).ToString.Trim + "' AND in_out = '" + strar(4).ToString.Trim + "'" + _
            '                           " GROUP BY label, lan, in_ip ORDER BY COUNT(*) desc"
            'ShortDt_rwLock.AcquireWriterLock(Threading.Timeout.Infinite)
            'ErrorSave("MoreInfoAggregateOut1 Lock") '-------------------------
            'ErrorSave("MoreInfoAggregateOut1") '-------------------------
            Try
                Dim sqlstringD As String = "out_ip = " + IPtoInt(strar(1)).ToString + " AND tcp_udp = '" + (strar(3)).ToString.Trim + "' AND in_out = '" + strar(4).ToString.Trim + "'"
                Dim cdr() As DataRow = ShortDt.Select(sqlstringD)

                Dim CDt As New DataTable
                Dim KeyColumn(2) As DataColumn
                KeyColumn(0) = CDt.Columns.Add("label", Type.GetType("System.Char"))
                KeyColumn(1) = CDt.Columns.Add("lan", Type.GetType("System.Char"))
                KeyColumn(2) = CDt.Columns.Add("in_ip", Type.GetType("System.Int32"))
                CDt.Columns.Add("count", Type.GetType("System.Int32"))
                CDt.PrimaryKey = New DataColumn() {KeyColumn(0), KeyColumn(1), KeyColumn(2)}
                swstr = swstr + "1:" + sw.ElapsedMilliseconds.ToString + ", "
                For i = 0 To cdr.Length - 1
                    Dim k(2) As Object
                    k(0) = cdr(i).Item("label")
                    k(1) = cdr(i).Item("lan")
                    k(2) = cdr(i).Item("in_ip")
                    Dim foundRow As DataRow = CDt.Rows.Find(k)
                    If foundRow Is Nothing Then
                        CDt.Rows.Add(cdr(i).Item("label"), cdr(i).Item("lan"), cdr(i).Item("in_ip"), 1)
                    Else
                        foundRow.Item("count") = foundRow.Item("count") + 1
                    End If
                Next
                swstr = swstr + "2:" + sw.ElapsedMilliseconds.ToString + ", "
                Dim cdv As DataView = New DataView(CDt)
                cdv.Sort = "count DESC"
                'MsgBox("集計終わり:" + CDt.Rows.Count.ToString)
                Debug.WriteLine("MoreInfoAggregateOut:集計終わり:" + CDt.Rows.Count.ToString)
                'ErrorSave("MoreInfoAggregateOut2") '-------------------------
                swstr = swstr + "3:" + sw.ElapsedMilliseconds.ToString + ", "

                Dim str0 As String = ""
                'Dim ndt As New DataTable
                'str0 = "-- IN IP -- " + CheckMin.AddMinutes(-1 * AggregateShort).ToString("yyyy/MM/dd HH:mm") + " - " + CheckMin.ToString("yyyy/MM/dd HH:mm") + " ----" + "_"
                rstr = rstr + str0
                rstr = rstr + "Count, IP, label, lan, (host name)" + "_"
                'ErrorSave("MoreInfoAggregateOut3") '-------------------------
                For i = 0 To cdv.Count - 1
                    Dim ip As String = InttoIP(cdv(i).Item("in_ip"))
                    Dim hostname As String = GetHostName(cdv(i).Item("in_ip"))

                    str0 = cdv(i).Item("count").ToString + ", "
                    str0 = str0 + ip + ", "
                    str0 = str0 + cdv(i).Item("label").ToString + ", "
                    str0 = str0 + cdv(i).Item("lan").ToString + ", "
                    str0 = str0 + "(" + hostname + ")"
                    rstr = rstr + str0 + "_"
                Next
                'ErrorSave("MoreInfoAggregateOut4") '-------------------------
            Catch ex As Exception
                ErrorSave("MoreInfoAggregateOut: (" + sstr + ") " + ex.ToString)
            End Try
            'ShortDt_rwLock.ReleaseWriterLock()
            'ErrorSave("MoreInfoAggregateOut1 Release") '-------------------------
            'ErrorSave("MoreInfoAggregateOut5") '-------------------------
            'ストップウォッチを止める 
            sw.Stop()
            If DebugFlg Then
                swstr = swstr + "4:" + sw.ElapsedMilliseconds.ToString + ", "
                rstr = rstr + swstr + "_"
            End If

        End If

        Return rstr
    End Function

    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click
        'Dim CBIAr() As ComboBox
        'Dim CBKAr() As ComboBox
        'Dim TBJAr() As TextBox
        Dim str As String = ""
        Dim i As Integer
        For i = 0 To 3
            If CBIAr(i).Text <> "" And CBKAr(i).Text <> "" And TBJAr(i).Text <> "" Then
                'j = Array.IndexOf(CurFieldJp, Combo1array(i).Text)
                'k = Array.IndexOf(sstr, Combo2array(i).Text)
                'If j >= 0 And k >= 0 Then
                'End If
                'Dim ItmAr() As String = {"label", "lan", "tcp_udp", "in_out", "date_time", "in_ip", "in_port", "out_ip", "out_port"}
                If str <> "" Then
                    str = str + " AND "
                End If
                str = str + CBIAr(i).Text + " "
                Dim sq As String = ""
                Dim Tx As String = TBJAr(i).Text
                If CBIAr(i).Text = "in_ip" Or CBIAr(i).Text = "out_ip" Then
                    If IPtoInt(TBJAr(i).Text) = 0 Then
                        MsgBox("IPが不正です")
                        Exit Sub
                    Else
                        Tx = IPtoInt(TBJAr(i).Text)
                    End If
                    sq = ""
                ElseIf CBIAr(i).Text = "in_port" Or CBIAr(i).Text = "out_port" Then
                    Try
                        Tx = CInt(TBJAr(i).Text) - 32768
                    Catch ex As Exception
                        MsgBox("ポート番号が不正です")
                        Exit Sub
                    End Try
                    sq = ""
                Else
                    sq = "'"
                End If
                If CBKAr(i).Text = "含む" Then
                    str = str & "LIKE " & sq & "%" & Tx.Replace("'", "''") & "%" & sq
                ElseIf CBKAr(i).Text = "前方一致" Then
                    str = str & "LIKE " & sq & Tx.Replace("'", "''") & "%" & sq
                ElseIf CBKAr(i).Text = "後方一致" Then
                    str = str & "LIKE " & sq & "%" & Tx.Replace("'", "''") & sq
                Else
                    str = str & CBKAr(i).Text & " " & sq & Tx.Replace("'", "''") & sq
                End If

            End If
        Next
        TextBox9.Text = str
        Count()
        GraphDrow()
    End Sub

    Private Sub CheckBox1_CheckedChanged(sender As Object, e As System.EventArgs) Handles CheckBox1.CheckedChanged
        'If CheckBox1.Checked Then
        '    SqlSubString = TextBox9.Text
        'Else
        '    SqlSubString = ""
        'End If
        Count()
        GraphDrow()
    End Sub

    '>>ボタン
    Private Sub Button4_Click(sender As System.Object, e As System.EventArgs) Handles Button4.Click
        Static cw As Integer = 0
        If cw = 0 Then
            TableLayoutPanel2.ColumnStyles(1).Width = 250
            cw = 250
            SplitContainer3.SplitterDistance = SplitContainer3.Height / 2
            DataGridView1.Visible = True
            Button4.Text = "<<"
        Else
            TableLayoutPanel2.ColumnStyles(1).Width = 0
            cw = 0
            SplitContainer3.SplitterDistance = SplitContainer3.Height
            DataGridView1.Visible = False
            Button4.Text = ">>"
            CheckBox1.Checked = False
        End If
    End Sub

    Private Sub ToolStripMenuItem2_Click(sender As System.Object, e As System.EventArgs) Handles ToolStripMenuItem2.Click
        Form2.ShowDialog()
    End Sub

    Private Sub ToolStripMenuItem3_Click(sender As System.Object, e As System.EventArgs) Handles ToolStripMenuItem3.Click
        HelpForm.ShowDialog()
    End Sub
End Class
