﻿Public Class Form2

    Private Sub Form2_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        TextBox1.Text = MdbPath
        TextBox2.Text = ParentProductName
        TextBox3.Text = SearchInterval
        TextBox4.Text = FontSize
    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        If FolderBrowserDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            TextBox1.Text = FolderBrowserDialog1.SelectedPath
        End If
    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        Dim savestring As String = Me.ProductName + vbCrLf

        'MDBパス
        savestring = savestring + TextBox1.Text + vbCrLf
        '親プログラム名
        savestring = savestring + TextBox2.Text + vbCrLf
        '検索幅(分)
        Try
            Dim a As Integer = CInt(TextBox3.Text)
            If a <= 0 Then
                MsgBox("検索幅(分)は正の整数にしてください")
                Exit Sub
            End If
            savestring = savestring + a.ToString + vbCrLf
        Catch ex As Exception
            MsgBox("検索幅(分)の値が不正です")
            Exit Sub
        End Try
        '文字サイズ
        Try
            Dim a As Integer = CInt(TextBox4.Text)
            If a <= 0 Then
                MsgBox("文字サイズは正の値にしてください")
                Exit Sub
            End If
            savestring = savestring + a.ToString + vbCrLf
        Catch ex As Exception
            MsgBox("文字サイズの値が不正です")
            Exit Sub
        End Try
        'MsgBox(savestring)

        If System.IO.Directory.Exists(SettingIniPathName) = False Then 'iniファイルのディレクトリが無ければ作成
            System.IO.Directory.CreateDirectory(SettingIniPathName)
        End If
        Dim curpath As String
        curpath = SettingIniPathName + "\" + Me.ProductName + ".ini"
        Try
            System.IO.File.WriteAllText(curpath, savestring)
            MsgBox(curpath + "に保存しました" + vbCrLf + "設定は次回起動時から有効です")
        Catch ex As Exception
            MsgBox(curpath + "に保存できませんでした")
        End Try
        Me.Close()

    End Sub

End Class