﻿Public Class HelpForm
    Private Sub HelpForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'WebBrowser1.DocumentText = HelpText
        WebBrowser1.DocumentText = "" + _
            "<html><body>" + vbCrLf + _
            "<H2>SyslogReceiveSup説明</H2>" + vbCrLf + _
            "SyslogReceive2（YAMAHA NVR500 の Syslog を受信して集計するソフト）で作成したデータファイルを集計して表示するソフトです。<br>" + vbCrLf + _
            "SyslogReceive2は動作時に指定時間ごとの集計結果のログを作成しますが、元になるデータをMDBファイルとして保存しています。<br>" + vbCrLf + _
            "このソフトはそのMDBファイルを読み込んで集計し直す時に使用します。<br>" + vbCrLf + _
            "集計方法はSyslogReceive2と同じで指定時間間隔でのLAN側IP/WAN側IP毎のログ数を集計して多い順に表示します。<br>" + vbCrLf + _
            "また、各集計結果から、さらに細かく分類した集計を確認できます。<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<H3>メイン画面</H3>" + vbCrLf + _
            "上左側に操作用のボタンやテキストボックスがあります。<br>" + vbCrLf + _
            "上右側にログの数を5分毎に集計したグラフが表示されます。<br>" + vbCrLf + _
            "下左側リストボックスに集計結果が表示されます。上段がLAN側IP、下段がWAN側IPで集計した結果です。<br>" + vbCrLf + _
            "下右側テキストボックスには下左側のリストをクリックした場合そのIPの詳細な集計結果が表示されます。<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<b>【操作部】</b><br>" + vbCrLf + _
            "<b>ファイル選択：</b>集計するファイルを選択指定します。右の「...」ボタンを押すと選択ダイアログが開きます。<br>" + vbCrLf + _
            "<b>日付選択：</b>集計する日付を選択します。テキストボックスに直接書き込むか、右の▼ボタンを押すとカレンダーが開くので日を選択します。<br>" + vbCrLf + _
            "<b>開始時刻：</b>集計時間範囲の開始時刻を指定します。テキストボックスにHH:MM形式で指定するか、右上のグラフの該当箇所をクリックすることで指定できます。<br>" + vbCrLf + _
            "<b>集計時間(分)：</b>集計時間範囲の長さを分で指定します。初期値は5分です。<br>" + vbCrLf + _
            "<b>集計ボタン：</b>ボタンを押すと実際の集計が行われます。グラフをクリックした場合は自動的に集計が行われますが、テキストボックスを書き換えた場合は自動的には集計されないのでボタンを押してください。<br>" + vbCrLf + _
            "<b>＞＞ボタン：</b>集計の条件を指定したい場合に使用する設定部分を表示します。また右下に集計結果を表示するDataGridViewが表示されます。初期状態では表示されていません。<br>" + vbCrLf + _
            "もう一度押すと元に戻ります。<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<b>【補助操作部】</b><br>" + vbCrLf + _
            "集計の条件を指定したい場合に使用する設定部分です。<br>" + vbCrLf + _
            "SQL文の知識が必要です。<br>" + vbCrLf + _
            "コンボボックス、コンボボックス、テキストボックスの並びが4行あります。<br>" + vbCrLf + _
            "<b>左のコンボボックス</b>はカラム名を指定します。label, lan, tcp_udp, in_out, in_ip, in_port, out_ip, out_port、から選びます。<br>" + vbCrLf + _
            "<b>中央のコンボボックス</b>は条件を指定します、=, >, <, >=, <=, <>, 含む, 前方一致, 後方一致、から選びます。<br>" + vbCrLf + _
            "<b>右のテキストボックス</b>は検索したい文字列を指定します。<br>" + vbCrLf + _
            "１行全部を指定することで1つの検索条件が作成されます。指定漏れがあると検索式は作成されません。<br>" + vbCrLf + _
            "全部で4行あるので、4つの検索条件を指定できます。それぞれの条件はANDで結合されます。<br>" + vbCrLf + _
            "<b>「式作成」ボタン</b>を押すと作成されたSQL文は右の大き目のテキストボックスに表示されます。<br>" + vbCrLf + _
            "<b>右の大き目のテキストボックス</b>には作成されたSQL文が表示され、検索時にはこのテキストボックスの文字列が使用されます。<br>" + vbCrLf + _
            "<b>「条件を検索時に適用」チェックボックス</b>がチェックされていると検索時に作成したSQL文が適用されます。<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<b>【グラフ】</b><br>" + vbCrLf + _
            "グラフ部には1日分のログを5分毎に集計した棒グラフが表示されます。<br>" + vbCrLf + _
            "グラフをクリックするとその位置が時分として左の開始時刻部分に挿入されます。<br>" + vbCrLf + _
            "グラフ上部に赤色の線が表示されるのは集計を行っている範囲を表しています。<br>" + vbCrLf + _
            "左上の数値は集係値の最大値を表します。<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<b>【集計リスト】</b><br>" + vbCrLf + _
            "左下に集計結果がリストとして多い順に表示されます。<br>" + vbCrLf + _
            "上段がLAN側IP、下段がWAN側IPでの集計結果です。<br>" + vbCrLf + _
            "LAN側の集計はIP、TCP/UDP、IN/OUTで場合分けして行います。<br>" + vbCrLf + _
            "WAN側の集計はIP、PORT、TCP/UDP、IN/OUTで場合分けして行います<br>" + vbCrLf + _
            "各リストをクリックすると、そのIPの詳細が左側のテキストボックスに表示されます。<br>" + vbCrLf + _
            "例として、LAN側のIPをクリックするとそのIPがアクセスしているWAN側のIPが分かります。<br>" + vbCrLf + _
            "またWAN側のIPをクリックするとそのIPにアクセスしているLAN側のIPが分かります。<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<b>メニュー→設定：</b>設定画面が表示されます。<br>" + vbCrLf + _
            "<b>メニュー→説明：</b>説明画面（この画面）が表示されます。<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<H3>設定画面</H3>" + vbCrLf + _
            "動作の設定を行います。設定を変更したら再起動してください。再起動しないと設定が反映されません。<br>" + vbCrLf + _
            "<b>MDBパス：</b>SyslogReceive2の作成するMDBファイルの入っているフォルダーを指定します。初期値は　マイドキュメント￥SyslogReceive2　です<br>" + vbCrLf + _
            "<b>親プログラム名：</b>初期値はSyslogReceive2です。MDBファイルのファイル名を作成する時に使用します。<br>" + vbCrLf + _
            "<b>検索幅：</b>集計時間範囲の長さを分で指定します。初期値は5分です。メイン画面の集計時間(分)部分に表示されます。<br>" + vbCrLf + _
            "<b>フォントサイズ：</b>メイン画面の結果表示用リストボックスとテキストボックスの文字の大きさをポイントで指定します。初期値は10です。<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<H3>各フィールドの説明</H3>" + vbCrLf + _
            "label は処理したメッセージの種類を記録します。NVR500の場合 'I':[INSPECT], 'R':Rejected, 'P':Passed, 'C':キャプチャーログです。DD-WRTの場合 'A':ACCEPT, 'D':DROP です。<br>" + vbCrLf + _
            "lan はNVR500の場合 メッセージに書かれているLAN1/LAN2の数字を記録します。DD-WRT では使いません。<br>" + vbCrLf + _
            "tcp_udp は TCP の場合'T'に、UDP の場合'U'に、ICMP の場合'I'に、その他は空欄になります<br>" + vbCrLf + _
            "in_out は NVR500の場合 メッセージ内に IN があれば'I'に、OUT があれば'O'になります。DD-WRTではACCEPTメッセージでは全て'O'に、DROPメッセージで br0 があれば'O'に、eth1 があれば'I'にしています。<br>" + vbCrLf + _
            "date_time は受信した時刻を記録しますが、メッセージ内に時刻が含まれる場合はその時刻を記録します(NVR500の[INSPECT]のみです)。変数型はDATEではなくIntegerです。DDHHMMSSの形で数値として記録します。<br>" + vbCrLf + _
            "in_ip はLAN側のIPを記録します。発信側受信側の順に並んでいたりするのでメッセージによって読み取り順を入れ替えたりしています。変数型はintegerです。???.???.??.??をそれぞれバイトに直して上下入れ替えてからIntegerに変換しています。<br>" + vbCrLf + _
            "in_port はLAN側のポート番号を記録します。変数型はSmallInt(16bit)です。元の値から32768を引いて保存しています。<br>" + vbCrLf + _
            "out_ip はWAN側のIPを記録します。変数型はintegerです。in_ipと同様の処理をしています<br>" + vbCrLf + _
            "out_port はWAN側のポート番号を記録します。変数型はSmallInt(16bit)です。in_portと同様の処理をしています<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "（注意点）ログの数と実際の転送量は比例しない。<br>" + vbCrLf + _
            "例えば激しくブラウジングすると大量のログが発生しますが、動画視聴ではそれほど発生しません。<br>" + vbCrLf + _
            "特にPassログを出力しない状態ではその差が顕著になります。<br>" + vbCrLf + _
            "ログの数とネットワーク負荷は比例しないことをわかった上でデータを見る必要があります。<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<H3>読み込むファイル</H3>" + vbCrLf + _
            "SyslogReceive2_yyyyMMdd.mdb<br>" + vbCrLf + _
            "SyslogReceive2Hostname_yyyyMMdd.mdb<br>" + vbCrLf + _
            "の２つを読み込んで集計します。<br>" + vbCrLf + _
            "yyyyMMdd部分は年月日を表します。このファイルは１日1個づつ作成されます。<br>" + vbCrLf + _
            "SyslogReceive2_yyyyMMdd.mdbがデータ本体でログの情報が保存されます。これが無いと集計できないのでエラーになります。<br>" + vbCrLf + _
            "SyslogReceive2Hostname_yyyyMMdd.mdbは補助ファイルでIPからホスト名やマックアドレスを検索したデータが保存されています。" + vbCrLf + _
            "これは無くても集計はできますが、ホスト名が表示されません。<br>" + vbCrLf + _
            "該当日付のファイルはファイル名の日付部分で判断するのでファイル名を書き換えると使用できなくなります。<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "<br>" + vbCrLf + _
            "</body></html>"
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Me.Close()
    End Sub

End Class